#ifndef WORLD_H
#define WORLD_H

#include <stdint.h>

#define W_CELL_SIZEPX 8
#define W_SIZE_X 160
#define W_SIZE_Y 16
                        //  p1  p2  p3
#define DEATH       -1  
#define EMPTY       0   //  _,  _,  _
#define EARTH       1   //  X,  Y,  _ (XY tileset)
#define BRICK       2

#define PLATEFORM   4   
#define TUYAU       5   //  X,  Y,  _ (XY tileset)
#define GIFT        6   //  s,  t,  n (state, type, number) [if number=0 state=1]
#define COIN        7   //  s,  _,  _ (state)

typedef struct 
{
    char type;
    char p1; // numéro de tile
    char p2; // visible, invisible, téléporteur/en train de tirer (canon par exemple)
    char p3;
} world_t;

world_t* world_get(int x, int y);

void display_cell(int cx, int cy, int sx, int sy);

void world_set(world_t * w);

void world_draw(int x, int y);

int world_get_real_x0(int x);
int world_get_real_y0(int y);


#define CTG_SOIL  1
#define CTG_EMPTY 2
#define CTG_DEATH 3
int world_get_ctg(int x, int y);

#endif